/***********************************************************************************************************************
**
** Copyright (C) 2021 BaseALT Ltd.
** Authors: Valery Sinelnikov <greh@basealt.ru>, Ivan Savin <svn17@basealt.ru>
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**
***********************************************************************************************************************/
#ifndef _ALTERATOR_GDBUS_H_
#define _ALTERATOR_GDBUS_H_
#include "alteratormodule.h"
#include "servicealterator.h"
#include <gmodule.h>
G_BEGIN_DECLS

#define ALTERATOR_TYPE_GDBUS (alterator_gdbus_get_type())
G_DECLARE_FINAL_TYPE (AlteratorGdbus, alterator_gdbus, ALTERATOR, GDBUS, GObject)


typedef struct _AlteratorGdbus AlteratorGdbus;


AlteratorGdbus*
alterator_gdbus_new(gchar* dirname, gchar* keyword);

GList*
alterator_gdbus_get_modules(AlteratorGdbus* self);

AlteratorService*
alterator_gdbus_get_service(AlteratorGdbus* self);

AlteratorModule*
alterator_gdbus_lookup_module(AlteratorGdbus* self, const gchar* object_path);

G_END_DECLS

#endif
//alterator
