/***********************************************************************************************************************
**
** Copyright (C) 2021 BaseALT Ltd.
** Authors: Valery Sinelnikov <greh@basealt.ru>, Ivan Savin <svn17@basealt.ru>
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**
***********************************************************************************************************************/
#ifndef _ALTERATOR_MODULE_H_
#define _ALTERATOR_MODULE_H_
#define _GNU_SOURCE
#include <glib-object.h>
#include <glib.h>
#include <glib/gstdio.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <stdio.h>

G_BEGIN_DECLS
#define PATH_TO_INTROSPECTION "/usr/share/dbus-1/interfaces/"
#define ERROR_XML "<node><interface name='ru.basealt.alterator.error_xml'> </interface> </node>"
#define KEY_WORD "alterator"
#define ALTERATOR_TYPE_MODULE alterator_module_get_type()
extern gchar* domainalt;
#define G_LOG_DOMAIN    ((gchar*) domainalt)

G_DECLARE_FINAL_TYPE (AlteratorModule, alterator_module, ALTERATOR, MODULE, GObject)

typedef struct _AlteratorModule AlteratorModule;


AlteratorModule*
alterator_module_new(const gchar* path, gchar* filename);


void
alterator_module_free(AlteratorModule* self);

gboolean
alterator_module_state(AlteratorModule* self);

GDBusNodeInfo*
alterator_module_get_introspection_data(AlteratorModule* self);

gchar*
alterator_module_get_objectname(AlteratorModule* self);

gchar*
alterator_module_get_actionid_default(AlteratorModule* self);

gchar*
alterator_module_get_actionid_module(AlteratorModule* self);

gchar*
alterator_module_get_modulename(AlteratorModule* self);


void
alterator_module_set_objectname(AlteratorModule* self, gchar* objectname);



G_END_DECLS

#endif
