/***********************************************************************************************************************
**
** Copyright (C) 2021 BaseALT Ltd.
** Authors: Valery Sinelnikov <greh@basealt.ru>, Ivan Savin <svn17@basealt.ru>
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**
***********************************************************************************************************************/
#include "logalteratordbus.h"

static guint log_priority = 0;

guint
get_log_priority(void){
    return log_priority;
}
void
set_log_priority(guint priority){
    log_priority = priority;
}

void
log_alterator_gdbus_cb(const gchar *log_domain,
                       GLogLevelFlags log_level,
                       const gchar *message,
                       gpointer user_data){
    guint level = LOG_ALERT;
    guint level_priority = 7;
    switch (log_level & G_LOG_LEVEL_MASK)
    {
    case G_LOG_LEVEL_ERROR:
        level = LOG_CRIT; // 2
        level_priority = 1;
        break;
    case G_LOG_LEVEL_CRITICAL:
        level = LOG_ERR; // 3
        level_priority = 2;
        break;
    case G_LOG_LEVEL_WARNING:
        level = LOG_WARNING; // 4
        level_priority = 3;
        break;
    case G_LOG_LEVEL_MESSAGE:
        level = LOG_NOTICE; // 5
        level_priority = 4;
        break;
    case G_LOG_LEVEL_INFO:
        level = LOG_INFO; // 6
        level_priority = 5;
        break;
    case G_LOG_LEVEL_DEBUG:
        level = LOG_DEBUG; // 7
        level_priority = 6;
        break;
    }
    if(log_priority >= level_priority){
        sd_journal_print(level, "%s", message);
    }
}
