/***********************************************************************************************************************
**
** Copyright (C) 2021 BaseALT Ltd.
** Authors: Valery Sinelnikov <greh@basealt.ru>, Ivan Savin <svn17@basealt.ru>
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**
***********************************************************************************************************************/
#ifndef MAKERESPONSETODBUS_H
#define MAKERESPONSETODBUS_H

#include <glib/gstdio.h>
#include <gio/gio.h>
#include "requesttowoobus.h"
#include <gmodule.h>

extern gchar* domainalt;
#define G_LOG_DOMAIN    ((gchar*) domainalt)

/**
* CONTENT_BETWEEN_METHODNAME retrieves substring with variables
*/
#define CONTENT_BETWEEN_METHODNAME "(?<=\\%s\\/%s\\\" ).+?((?=\\) \\(\\\"\\%s\\/%s)|(?=\\)\\)$))"
#define CONTENT_BETWEEN_METHODNAME_EMPTY "(?<=\\%s\" ).+?((?=\\) \\(\\\"\\%s\\/%s)|(?=\\)\\)$))"
#define MAX_SIGNATURE_SIZE 100

/**
* VARIABLE_VALUE takes the value of a variable with name from (*out)->name except for the last.
* It could be #f, #t, or text in quotes.
*
* LAST_VARIABLE_VALUE takes the value of the last variable with name from (*out)->name.
*/

#define VARIABLE_VALUE "(?<=%s ).+(?=%s)"
#define LAST_VARIABLE_VALUE "(?<=%s ).+(?=\)"
#define REMOVE_QUOTES "(?<=\").+(?=\")"

GVariant* make_response_for_dbus(GList* list, GDBusMethodInfo* method);
GList* converting_answer_to_strings(gchar* request, GList* list, const gchar* object_path, const GDBusMethodInfo* method);

#endif // MAKERESPONSETODBUS_H
