/***********************************************************************************************************************
**
** Copyright (C) 2021 BaseALT Ltd.
** Authors: Valery Sinelnikov <greh@basealt.ru>, Ivan Savin <svn17@basealt.ru>
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**
***********************************************************************************************************************/
#include "servicealterator.h"


struct _AlteratorService {
    GObjectClass parent_class;
    GDBusNodeInfo *introspection_data;
    gchar* introspection_xml;
};
G_DEFINE_TYPE (AlteratorService, alterator_service, G_TYPE_OBJECT)

static const gchar* xml = "<node>"
  "  <interface name='ru.basealt.alterator.service'>"
  "    <method name='set_log_priority'>"
  "      <arg direction='in'  type='i' name='priority' />"
  "    </method>"
  "    <method name='get_log_priority'>"
  "      <arg direction='out'  type='i' name='priority' />"
  "    </method>"
  "  </interface>"
  "</node>";

static void
alterator_service_class_init(AlteratorServiceClass* self)
{
}

static void
alterator_service_init(AlteratorService* self)
{
}

GDBusNodeInfo*
alterator_service_get_introspection_data(AlteratorService* self){
    g_info("alterator_service_get_introspection_data()");
    return self->introspection_data;
}


AlteratorService*
alterator_service_new(void){
    AlteratorService* self = ALTERATOR_SERVICE(g_object_new(ALTERATOR_TYPE_SERVICE, NULL));
    self->introspection_data = g_dbus_node_info_new_for_xml(xml, NULL);
    g_info("alterator_service_new()");
    return self;
}


